<?php

/**
 * Base static class for performing query and update operations on the 'node' table.
 *
 * 
 *
 * @package    plugins.catalyz.lib.model.om
 */
abstract class BaseNodePeer {

	/** the default database name for this class */
	const DATABASE_NAME = 'propel';

	/** the table name for this class */
	const TABLE_NAME = 'node';

	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = 'plugins.catalyz.lib.model.Node';

	/** The total number of columns. */
	const NUM_COLUMNS = 16;

	/** The number of lazy-loaded columns. */
	const NUM_LAZY_LOAD_COLUMNS = 0;


	/** the column name for the ID field */
	const ID = 'node.ID';

	/** the column name for the IS_PUBLIC field */
	const IS_PUBLIC = 'node.IS_PUBLIC';

	/** the column name for the NODE_CLASS field */
	const NODE_CLASS = 'node.NODE_CLASS';

	/** the column name for the URL_PROVIDER field */
	const URL_PROVIDER = 'node.URL_PROVIDER';

	/** the column name for the OPEN_TARGET_PROVIDER field */
	const OPEN_TARGET_PROVIDER = 'node.OPEN_TARGET_PROVIDER';

	/** the column name for the PERMS_TYPE field */
	const PERMS_TYPE = 'node.PERMS_TYPE';

	/** the column name for the CREDENTIALS field */
	const CREDENTIALS = 'node.CREDENTIALS';

	/** the column name for the TREE_LEFT field */
	const TREE_LEFT = 'node.TREE_LEFT';

	/** the column name for the TREE_RIGHT field */
	const TREE_RIGHT = 'node.TREE_RIGHT';

	/** the column name for the TREE_PARENT field */
	const TREE_PARENT = 'node.TREE_PARENT';

	/** the column name for the TREE_ID field */
	const TREE_ID = 'node.TREE_ID';

	/** the column name for the IS_VISIBLE_IN_MENU field */
	const IS_VISIBLE_IN_MENU = 'node.IS_VISIBLE_IN_MENU';

	/** the column name for the CURRENT_LAYOUT field */
	const CURRENT_LAYOUT = 'node.CURRENT_LAYOUT';

	/** the column name for the CURRENT_LAYOUT_TYPE field */
	const CURRENT_LAYOUT_TYPE = 'node.CURRENT_LAYOUT_TYPE';

	/** the column name for the CREATED_AT field */
	const CREATED_AT = 'node.CREATED_AT';

	/** the column name for the UPDATED_AT field */
	const UPDATED_AT = 'node.UPDATED_AT';

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;


	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'IsPublic', 'NodeClass', 'UrlProvider', 'OpenTargetProvider', 'PermsType', 'Credentials', 'TreeLeft', 'TreeRight', 'TreeParent', 'TreeId', 'IsVisibleInMenu', 'CurrentLayout', 'CurrentLayoutType', 'CreatedAt', 'UpdatedAt', ),
		BasePeer::TYPE_COLNAME => array (NodePeer::ID, NodePeer::IS_PUBLIC, NodePeer::NODE_CLASS, NodePeer::URL_PROVIDER, NodePeer::OPEN_TARGET_PROVIDER, NodePeer::PERMS_TYPE, NodePeer::CREDENTIALS, NodePeer::TREE_LEFT, NodePeer::TREE_RIGHT, NodePeer::TREE_PARENT, NodePeer::TREE_ID, NodePeer::IS_VISIBLE_IN_MENU, NodePeer::CURRENT_LAYOUT, NodePeer::CURRENT_LAYOUT_TYPE, NodePeer::CREATED_AT, NodePeer::UPDATED_AT, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'is_public', 'node_class', 'url_provider', 'open_target_provider', 'perms_type', 'credentials', 'tree_left', 'tree_right', 'tree_parent', 'tree_id', 'is_visible_in_menu', 'current_layout', 'current_layout_type', 'created_at', 'updated_at', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'IsPublic' => 1, 'NodeClass' => 2, 'UrlProvider' => 3, 'OpenTargetProvider' => 4, 'PermsType' => 5, 'Credentials' => 6, 'TreeLeft' => 7, 'TreeRight' => 8, 'TreeParent' => 9, 'TreeId' => 10, 'IsVisibleInMenu' => 11, 'CurrentLayout' => 12, 'CurrentLayoutType' => 13, 'CreatedAt' => 14, 'UpdatedAt' => 15, ),
		BasePeer::TYPE_COLNAME => array (NodePeer::ID => 0, NodePeer::IS_PUBLIC => 1, NodePeer::NODE_CLASS => 2, NodePeer::URL_PROVIDER => 3, NodePeer::OPEN_TARGET_PROVIDER => 4, NodePeer::PERMS_TYPE => 5, NodePeer::CREDENTIALS => 6, NodePeer::TREE_LEFT => 7, NodePeer::TREE_RIGHT => 8, NodePeer::TREE_PARENT => 9, NodePeer::TREE_ID => 10, NodePeer::IS_VISIBLE_IN_MENU => 11, NodePeer::CURRENT_LAYOUT => 12, NodePeer::CURRENT_LAYOUT_TYPE => 13, NodePeer::CREATED_AT => 14, NodePeer::UPDATED_AT => 15, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'is_public' => 1, 'node_class' => 2, 'url_provider' => 3, 'open_target_provider' => 4, 'perms_type' => 5, 'credentials' => 6, 'tree_left' => 7, 'tree_right' => 8, 'tree_parent' => 9, 'tree_id' => 10, 'is_visible_in_menu' => 11, 'current_layout' => 12, 'current_layout_type' => 13, 'created_at' => 14, 'updated_at' => 15, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
	);

	/**
	 * @return     MapBuilder the map builder for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('plugins.catalyz.lib.model.map.NodeMapBuilder');
	}
	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return     array The PHP to DB name map for this peer
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @deprecated Use the getFieldNames() and translateFieldName() methods instead of this.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = NodePeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	/**
	 * Translates a fieldname to another type
	 *
	 * @param      string $name field name
	 * @param      string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param      string $toType   One of the class type constants
	 * @return     string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param      string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     array A list of field names
	 */

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param      string $alias The alias for the current table.
	 * @param      string $column The column name for current table. (i.e. NodePeer::COLUMN_NAME).
	 * @return     string
	 */
	public static function alias($alias, $column)
	{
		return str_replace(NodePeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	/**
	 * Add all the columns needed to create a new object.
	 *
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param      criteria object containing the columns to add.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(NodePeer::ID);

		$criteria->addSelectColumn(NodePeer::IS_PUBLIC);

		$criteria->addSelectColumn(NodePeer::NODE_CLASS);

		$criteria->addSelectColumn(NodePeer::URL_PROVIDER);

		$criteria->addSelectColumn(NodePeer::OPEN_TARGET_PROVIDER);

		$criteria->addSelectColumn(NodePeer::PERMS_TYPE);

		$criteria->addSelectColumn(NodePeer::CREDENTIALS);

		$criteria->addSelectColumn(NodePeer::TREE_LEFT);

		$criteria->addSelectColumn(NodePeer::TREE_RIGHT);

		$criteria->addSelectColumn(NodePeer::TREE_PARENT);

		$criteria->addSelectColumn(NodePeer::TREE_ID);

		$criteria->addSelectColumn(NodePeer::IS_VISIBLE_IN_MENU);

		$criteria->addSelectColumn(NodePeer::CURRENT_LAYOUT);

		$criteria->addSelectColumn(NodePeer::CURRENT_LAYOUT_TYPE);

		$criteria->addSelectColumn(NodePeer::CREATED_AT);

		$criteria->addSelectColumn(NodePeer::UPDATED_AT);

	}

	const COUNT = 'COUNT(node.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT node.ID)';

	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct Whether to select only distinct columns (You can also set DISTINCT modifier in Criteria).
	 * @param      Connection $con
	 * @return     int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;

		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(NodePeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(NodePeer::COUNT);
		}

		// just in case we're grouping: add those columns to the select statement
		foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = NodePeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
	/**
	 * Method to select one object from the DB.
	 *
	 * @param      Criteria $criteria object used to create the SELECT statement.
	 * @param      Connection $con
	 * @return     Node
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = NodePeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	/**
	 * Method to do selects.
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con
	 * @return     array Array of selected Objects
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return NodePeer::populateObjects(NodePeer::doSelectRS($criteria, $con));
	}
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 *
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return     ResultSet The resultset object with numerically-indexed fields.
	 * @see        BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{

    foreach (sfMixer::getCallables('BaseNodePeer:doSelectRS:doSelectRS') as $callable)
    {
      call_user_func($callable, 'BaseNodePeer', $criteria, $con);
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			NodePeer::addSelectColumns($criteria);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.
		return BasePeer::doSelect($criteria, $con);
	}
	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
		// set the class once to avoid overhead in the loop
		$cls = NodePeer::getOMClass();
		$cls = sfPropel::import($cls);
		// populate the object(s)
		while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

  /**
   * Selects a collection of Node objects pre-filled with their i18n objects.
   *
   * @return array Array of Node objects.
   * @throws PropelException Any exceptions caught during processing will be
   *     rethrown wrapped into a PropelException.
   */
  public static function doSelectWithI18n(Criteria $c, $culture = null, $con = null)
  {
    // we're going to modify criteria, so copy it first
    $c = clone $c;
    if ($culture === null)
    {
      $culture = sfPropel::getDefaultCulture();
    }


    foreach (sfMixer::getCallables('BaseNodePeer:doSelectJoin:doSelectJoin') as $callable)
    {
      call_user_func($callable, 'BaseNodePeer', $c, $con);
    }


    // Set the correct dbName if it has not been overridden
    if ($c->getDbName() == Propel::getDefaultDB())
    {
      $c->setDbName(self::DATABASE_NAME);
    }

    NodePeer::addSelectColumns($c);
    $startcol = (NodePeer::NUM_COLUMNS - NodePeer::NUM_LAZY_LOAD_COLUMNS) + 1;

    NodeI18nPeer::addSelectColumns($c);

    $c->addJoin(NodePeer::ID, NodeI18nPeer::ID);
    $c->add(NodeI18nPeer::CULTURE, $culture);

    $rs = BasePeer::doSelect($c, $con);
    $results = array();

    while($rs->next()) {

      $omClass = NodePeer::getOMClass();

      $cls = sfPropel::import($omClass);
      $obj1 = new $cls();
      $obj1->hydrate($rs);
      $obj1->setCulture($culture);

      $omClass = NodeI18nPeer::getOMClass($rs, $startcol);

      $cls = sfPropel::import($omClass);
      $obj2 = new $cls();
      $obj2->hydrate($rs, $startcol);

      $obj1->setNodeI18nForCulture($obj2, $culture);
      $obj2->setNode($obj1);

      $results[] = $obj1;
    }
    return $results;
  }


  /**
   * Returns the i18n model class name.
   *
   * @return string The i18n model class name
   */
  public static function getI18nModel()
  {
    return 'NodeI18n';
  }


  static public function getUniqueColumnNames()
  {
    return array();
  }
	/**
	 * Returns the TableMap related to this peer.
	 * This method is not needed for general use but a specific application could have a need.
	 * @return     TableMap
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	/**
	 * The class that the Peer will make instances of.
	 *
	 * This uses a dot-path notation which is tranalted into a path
	 * relative to a location on the PHP include_path.
	 * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
	 *
	 * @return     string path.to.ClassName
	 */
	public static function getOMClass()
	{
		return NodePeer::CLASS_DEFAULT;
	}

	/**
	 * Method perform an INSERT on the database, given a Node or Criteria object.
	 *
	 * @param      mixed $values Criteria or Node object containing data that is used to create the INSERT statement.
	 * @param      Connection $con the connection to use
	 * @return     mixed The new primary key.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseNodePeer:doInsert:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseNodePeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} else {
			$criteria = $values->buildCriteria(); // build Criteria from Node object
		}

		$criteria->remove(NodePeer::ID); // remove pkey col since this table uses auto-increment


		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		
    foreach (sfMixer::getCallables('BaseNodePeer:doInsert:post') as $callable)
    {
      call_user_func($callable, 'BaseNodePeer', $values, $con, $pk);
    }

    return $pk;
	}

	/**
	 * Method perform an UPDATE on the database, given a Node or Criteria object.
	 *
	 * @param      mixed $values Criteria or Node object containing data that is used to create the UPDATE statement.
	 * @param      Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseNodePeer:doUpdate:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseNodePeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity

			$comparison = $criteria->getComparison(NodePeer::ID);
			$selectCriteria->add(NodePeer::ID, $criteria->remove(NodePeer::ID), $comparison);

		} else { // $values is Node object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
		}

		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$ret = BasePeer::doUpdate($selectCriteria, $criteria, $con);
	

    foreach (sfMixer::getCallables('BaseNodePeer:doUpdate:post') as $callable)
    {
      call_user_func($callable, 'BaseNodePeer', $values, $con, $ret);
    }

    return $ret;
  }

	/**
	 * Method to DELETE all rows from the node table.
	 *
	 * @return     int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; // initialize var to track total num of affected rows
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			$affectedRows += BasePeer::doDeleteAll(NodePeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Method perform a DELETE on the database, given a Node or Criteria object OR a primary key value.
	 *
	 * @param      mixed $values Criteria or Node object or primary key or array of primary keys
	 *              which is used to create the DELETE statement
	 * @param      Connection $con the connection to use
	 * @return     int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(NodePeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; // rename for clarity
		} elseif ($values instanceof Node) {

			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(NodePeer::ID, (array) $values, Criteria::IN);
		}

		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; // initialize var to track total num of affected rows

		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Validates all modified columns of given Node object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param      Node $obj The object to validate.
	 * @param      mixed $cols Column name or array of column names.
	 *
	 * @return     mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(Node $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(NodePeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(NodePeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(NodePeer::DATABASE_NAME, NodePeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = NodePeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	/**
	 * Retrieve a single object by pkey.
	 *
	 * @param      mixed $pk the primary key.
	 * @param      Connection $con the connection to use
	 * @return     Node
	 */
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(NodePeer::DATABASE_NAME);

		$criteria->add(NodePeer::ID, $pk);


		$v = NodePeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param      array $pks List of primary keys
	 * @param      Connection $con the connection to use
	 * @throws     PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(NodePeer::ID, $pks, Criteria::IN);
			$objs = NodePeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} // BaseNodePeer

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {
		BaseNodePeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	Propel::registerMapBuilder('plugins.catalyz.lib.model.map.NodeMapBuilder');
}
